Redmine - Feature #32545

Plugin API for adding a new notification
2019-12-02 10:08 - Hong Cheu Lim

Status: New Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Plugin API Estimated time: 0.00 hour
Target version: Candidate for next major release

Resolution:

Description

In lib/redmine/notifiable.rb, there is a TODO: Plugin API for adding a new notification?.
| found out that, one can provide this API via Redmine Hooks, although | dont know if this is the correct approach.
The patch below seems to be working at least for me (Redmine 4.0.5, ruby 2.6.5p114 (2019-10-01 revision 67812) [x86_64-linux]).

diff --git a/lib/redmine/notifiable.rb b/lib/redmine/notifiable.rb

index 41£fd736..822d216 100644

—-—— a/lib/redmine/notifiable.rb

+++ b/lib/redmine/notifiable.rb

@@ -21,6 +21,9 Q@ module Redmine
notifications << Notifiable.new('message_posted')
notifications << Notifiable.new('wiki_content_added"')
notifications << Notifiable.new('wiki_content_updated')

+ Redmine: :Hook.call_hook (:add_notifiable) .each do |notifiable|
+ notifications += notifiable
+ end
notifications
end
end
In any plugin

# In plugins/my_plugin/lib/hooks.rb
module MyPluginHooks
class MyPluginHooks < Redmine: :Hook::Listener
def add_notifiable (_context)
[Redmine: :Notifiable.new('my_plugin_new_notifiable')]
end
end
end

# In plugins/my_plugin/init.rb
require_relative 'lib/hooks.rb'

# Now we can use
Setting.notified_events.include? ('my_plugin_new_notifiable')

History

#1 - 2020-11-29 06:16 - Go MAEDA

- Category changed from Email notifications to Plugin API

#2 - 2023-04-16 20:47 - Vasiliy Gagarskiy

Any news?

2025-05-01 1/2




#3 - 2023-04-28 12:08 - Vasiliy Gagarskiy
Hong Cheu Lim wrote:
In lib/redmine/notifiable.rb, there is a TODO: Plugin API for adding a new notification?.

| found out that, one can provide this APl via Redmine Hooks, although | dont know if this is the correct approach.
The patch below seems to be working at least for me (Redmine 4.0.5, ruby 2.6.5p114 (2019-10-01 revision 67812) [x86_64-linux]).

(-]

In any plugin

(-]

Go MAEDA Do you have any thoughts about plugin API, maybe ROADMAP?

#4 - 2023-05-01 05:16 - Go MAEDA

- Target version set to Candidate for next major release
